unit Tar32;

(*
	TAR32API.H
		TAR32.DLL API header.
		by Yoshioka Tsuneo(QWF00133@nifty.ne.jp)
*)

interface

uses
	Windows, Messages, SysUtils,
	UnifyArc;

function _Tar(const Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall;
function _TarGetVersion: WORD; stdcall;
function _TarGetRunning: BOOL; stdcall;
(* 蔲
BOOL WINAPI _export TarGetBackGroundMode(VOID);/* NO IMPLEMENT:return FALSE */
BOOL WINAPI _export TarSetBackGroundMode(const BOOL _BackGroundMode);/* NO IMPLEMENT:return FALSE */
BOOL WINAPI _export TarGetCursorMode(VOID);/* NO IMPLEMENT:return FALSE */
BOOL WINAPI _export TarSetCursorMode(const BOOL _CursorMode);/* NO IMPLEMENT:return FALSE */
WORD WINAPI _export TarGetCursorInterval(VOID);/* NO IMPLEMENT:return 80 */
BOOL WINAPI _export TarSetCursorInterval(const WORD _Interval);/* NO IMPLEMENT:return FALSE */
*)
var
	Tar: function(const Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall = _Tar;
	TarGetVersion: function: WORD; stdcall = _TarGetVersion;
	TarGetRunning: function: BOOL; stdcall = _TarGetRunning;

//* NO IMPLEMENT:return -1 */
//function TarExtractMem(const HWND _hwndParent,LPCSTR _szCmdLine, LPBYTE _lpBuffer, const DWORD _dwSize,time_t *_lpTime, LPWORD _lpwAttr, LPDWORD _lpdwWriteSize):Integer; stdcall;

//* NO IMPLEMENT:return -1 */
//function TarCompressMem(const HWND _hwndParent,LPCSTR _szCmdLine, const LPBYTE _lpBuffer, const DWORD _dwSize,const time_t *_lpTime, const LPWORD _lpwAttr,LPDWORD _lpdwWriteSize):Integer; stdcall;

function _TarCheckArchive(FileName: LPCSTR; const Mode: Integer): BOOL; stdcall;
function _TarConfigDialog(const Wnd: HWND; ComBuffer: LPSTR; Mode: Integer): BOOL; stdcall;

var
	TarCheckArchive: function(FileName: LPCSTR; const Mode: Integer): BOOL; stdcall = _TarCheckArchive;
	//* Simple Dialog Only :return TRUE */
	TarConfigDialog: function (const Wnd: HWND; ComBuffer: LPSTR; Mode: Integer): BOOL; stdcall = _TarConfigDialog;

//int WINAPI _export TarGetFileCount(LPCSTR _szArcFile);
function _TarOpenArchive(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall;
function _TarCloseArchive(Arc: HARC): Integer; stdcall;
function _TarFindFirst(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
function _TarFindNext(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
//int WINAPI _export TarGetArcFileName(HARC _harc, LPSTR _lpBuffer,const int _nSize);

//DWORD WINAPI _export TarGetArcFileSize(HARC _harc);
//DWORD WINAPI _export TarGetArcOriginalSize(HARC _harc);

//* NO IMPLEMENT:return 0: */
//DWORD WINAPI _export TarGetArcCompressedSize(HARC _harc);

//* NO IMPLEMENT:return 0: */
//WORD WINAPI _export TarGetArcRatio(HARC _harc);

//WORD WINAPI _export TarGetArcDate(HARC _harc);
//WORD WINAPI _export TarGetArcTime(HARC _harc);

//* NO IMPLEMENT:return -1: */
//UINT WINAPI _export TarGetArcOSType(HARC _harc);

//int WINAPI _export TarGetFileName(HARC _harc, LPSTR _lpBuffer,const int _nSize);
//int WINAPI _export TarGetMethod(HARC _harc, LPSTR _lpBuffer,const int _nSize);
//DWORD WINAPI _export TarGetOriginalSize(HARC _harc);
//DWORD WINAPI _export TarGetCompressedSize(HARC _harc);
//WORD WINAPI _export TarGetRatio(HARC _harc);
//WORD WINAPI _export TarGetDate(HARC _harc);
//WORD WINAPI _export TarGetTime(HARC _harc);
function _TarGetWriteTime(Arc: HARC): DWORD; stdcall;
function _TarGetAccessTime(Arc: HARC): DWORD; stdcall;
function _TarGetCreateTime(Arc: HARC): DWORD; stdcall;
//DWORD WINAPI _export TarGetCRC(HARC _harc);
function _TarGetAttribute(Arc: HARC):Integer; stdcall;
//UINT WINAPI _export TarGetOSType(HARC _harc);

//BOOL WINAPI _export TarQueryFunctionList(const int _iFunction);

//BOOL WINAPI _export TarSetOwnerWindow(const HWND _hwnd);
//BOOL WINAPI _export TarClearOwnerWindow(void);
//BOOL WINAPI _export TarSetOwnerWindowEx(HWND _hwnd,ARCHIVERPROC *_lpArcProc);
//BOOL WINAPI _export TarKillOwnerWindowEx(HWND _hwnd);

var
	TarOpenArchive: function(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall = _TarOpenArchive;
	TarCloseArchive: function(Arc: HARC): Integer; stdcall = _TarCloseArchive;
	TarFindFirst: function(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall = _TarFindFirst;
	TarFindNext: function(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall = _TarFindNext;
	TarGetWriteTime: function(Arc: HARC): DWORD; stdcall = _TarGetWriteTime;
	TarGetAccessTime: function(Arc: HARC): DWORD; stdcall = _TarGetAccessTime;
	TarGetCreateTime: function(Arc: HARC): DWORD; stdcall = _TarGetCreateTime;
	TarGetAttribute: function(Arc: HARC):Integer; stdcall = _TarGetAttribute;

function _TarGetArchiveType(FileName: LPCSTR): Integer; stdcall;

var
	TarGetArchiveType: function(FileName: LPCSTR): Integer; stdcall = _TarGetArchiveType;

const
	ARCHIVETYPE_NORMAL = 0;
	ARCHIVETYPE_TAR    = 1;
	ARCHIVETYPE_TARGZ  = 2;
	ARCHIVETYPE_TARZ   = 3;
	ARCHIVETYPE_GZ     = 4;
	ARCHIVETYPE_Z      = 5;
	ARCHIVETYPE_TARBZ2 = 6;
	ARCHIVETYPE_BZ2	   = 7;

	ARCHIVETYPE_CPIO	  = 32;
	ARCHIVETYPE_CPIOGZ  = 32+4;
	ARCHIVETYPE_CPIOZ	  = 32+5;
	ARCHIVETYPE_CPIOBZ2	= 32+7;

	ARCHIVETYPE_AR		= 48;
	ARCHIVETYPE_ARGZ	= 48+4;
	ARCHIVETYPE_ARZ		= 48+5;
	ARCHIVETYPE_ARBZ2	= 48+7;

function TarEnabled: Boolean;

type
	ETarError = class(EArchiverError);

const
	Tar32Dll = 'tar32.dll';

implementation

type
	EError = ETarError;

const
	ArchiverDll = Tar32Dll;

var
	Module: THandle;

function GetProcAddress(ProcName: PChar): Pointer;
begin
	if Module = 0 then
	begin
		Module:= SafeLoadLibrary(ArchiverDll);
		if Module = 0 then
			raise EError.CreateFmt(SFaultLoad, [ArchiverDll]);
	end;
	Result := Windows.GetProcAddress(Module, ProcName);
	if Result = nil then
		raise EError.CreateFmt(SNoExistProc, [ArchiverDll, ProcName]);
end;

function TarEnabled: Boolean;
begin
	if Module = 0 then
		Module := SafeLoadLibrary(ArchiverDll);

	Result := Module <> 0;
end;

function _Tar(const Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall;
begin
	@Tar := GetProcAddress('Tar');
	Result := Tar(Wnd, CmdLine, Output, Size)
end;

function _TarGetVersion: WORD; stdcall;
begin
	@TarGetVersion := GetProcAddress('TarGetVersion');
	Result := TarGetVersion
end;

function _TarGetRunning: BOOL; stdcall;
begin
	@TarGetRunning := GetProcAddress('TarGetRunning');
	Result := TarGetRunning
end;

function _TarCheckArchive(FileName: LPCSTR; const Mode: Integer): BOOL; stdcall;
begin
	@TarCheckArchive := GetProcAddress('TarCheckArchive');
	Result := TarCheckArchive(FileName, Mode)
end;

function _TarConfigDialog(const Wnd: HWND; ComBuffer: LPSTR; Mode: Integer): BOOL; stdcall;
begin
	@TarConfigDialog := GetProcAddress('TarConfigDialog');
	Result := TarConfigDialog(Wnd, ComBuffer, Mode)
end;

function _TarOpenArchive(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall;
begin
	@TarOpenArchive := GetProcAddress('TarOpenArchive');
	Result := TarOpenArchive(Wnd, FileName, Mode)
end;

function _TarCloseArchive(Arc: HARC): Integer; stdcall;
begin
	@TarCloseArchive := GetProcAddress('TarCloseArchive');
	Result := TarCloseArchive(Arc)
end;

function _TarFindFirst(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
begin
	@TarFindFirst := GetProcAddress('TarFindFirst');
	Result := TarFindFirst(Arc, WildName, SubInfo)
end;

function _TarFindNext(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
begin
	@TarFindNext := GetProcAddress('TarFindNext');
	Result := TarFindNext(Arc, SubInfo)
end;

function _TarGetCreateTime(Arc: HARC): DWORD; stdcall;
begin
	@TarGetCreateTime := GetProcAddress('TarGetCreateTime');
	Result := TarGetCreateTime(Arc);
end;

function _TarGetWriteTime(Arc: HARC): DWORD; stdcall;
begin
	@TarGetWriteTime := GetProcAddress('TarGetWriteTime');
	Result := TarGetWriteTime(Arc);
end;

function _TarGetAccessTime(Arc: HARC): DWORD; stdcall;
begin
	@TarGetAccessTime := GetProcAddress('TarGetAccessTime');
	Result := TarGetAccessTime(Arc);
end;

function _TarGetAttribute(Arc: HARC): Integer; stdcall;
begin
	@TarGetAttribute := GetProcAddress('TarGetAttribute');
	Result := TarGetAttribute(Arc)
end;

function _TarGetArchiveType(FileName: LPCSTR): Integer; stdcall;
begin
	@TarGetArchiveType := GetProcAddress('TarGetArchiveType');
	Result := TarGetArchiveType(FileName)
end;

initialization

finalization

	if Module <> 0 then FreeLibrary(Module)

end.
