unit Unzip32;

interface

uses
	Windows, Messages, SysUtils,
	UnifyArc;

//#### LHA.DLL Compatible API (LHA.DLL V1.1 ƌ݊l API Qłj ####

function _UnZip(const Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall;
function _UnZipGetVersion: Word; stdcall;
function _UnZipGetRunning: Bool; stdcall;
function _UnZipGetBackGroundMode: BOOL; stdcall;
function _UnZipSetBackGroundMode(const BackGroundMode: BOOL): BOOL; stdcall;
function _UnZipGetCursorMode: BOOL; stdcall;
function _UnZipSetCursorMode(const CursorMode: BOOL): BOOL; stdcall;
function _UnZipGetCursorInterval: Word; stdcall;
function _UnZipSetCursorInterval(const Interval: Word): BOOL; stdcall;

var
	UnZip: function(const Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall = _UnZip;
	UnZipGetVersion: function: Word; stdcall = _UnZipGetVersion;
	UnZipGetRunning: function: Bool; stdcall = _UnZipGetRunning;
	UnZipGetBackGroundMode: function: BOOL; stdcall = _UnZipGetBackGroundMode;
	UnZipSetBackGroundMode: function(const BackGroundMode: BOOL): BOOL; stdcall = _UnZipSetBackGroundMode;
	UnZipGetCursorMode: function: BOOL; stdcall = _UnZipGetCursorMode;
	UnZipSetCursorMode: function(const CursorMode: BOOL): BOOL; stdcall = _UnZipSetCursorMode;
	UnZipGetCursorInterval: function: Word; stdcall = _UnZipGetCursorInterval;
	UnZipSetCursorInterval: function(const Interval: Word): BOOL; stdcall = _UnZipSetCursorInterval;

function _UnZipCommandLine(Wnd: HWND; hInst: THandle; CmdLine: LPCSTR; CmdShow: DWORD): Integer; stdcall;

var
	UnZipCommandLine: function(Wnd: HWND; hInst: THandle; CmdLine: LPCSTR; CmdShow: DWORD): Integer; stdcall = _UnZipCommandLine;

//ɓp

function _UnzipOpenArchive(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall;
function _UnzipCloseArchive(Arc: HARC): Integer; stdcall;
function _UnzipFindFirst(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
function _UnzipFindNext(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
function _UnzipGetAttribute(Arc: HARC): Integer; stdcall;
function _UnzipGetCreateTime(Arc: HARC): DWORD; stdcall;
function _UnzipGetAccessTime(Arc: HARC): DWORD; stdcall;
function _UnzipGetWriteTime(Arc: HARC): DWORD; stdcall;

var
	UnzipOpenArchive: function(const Wnd: HWND; FileName: LPCSTR;	const Mode: DWORD): HARC; stdcall = _UnzipOpenArchive;
	UnzipCloseArchive: function(Arc: HARC): Integer; stdcall = _UnzipCloseArchive;
	UnzipFindFirst: function (Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall = _UnzipFindFirst;
	UnzipFindNext: function (Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall = _UnzipFindNext;
	UnzipGetAttribute: function(Arc: HARC): Integer; stdcall = _UnzipGetAttribute;
	UnzipGetCreateTime: function(Arc: HARC): DWORD; stdcall = _UnzipGetCreateTime;
	UnzipGetAccessTime: function(Arc: HARC): DWORD; stdcall = _UnzipGetAccessTime;
	UnzipGetWriteTime: function(Arc: HARC): DWORD; stdcall = _UnzipGetWriteTime;

//#### Delphi ####

type
	EUnZipError = class(EArchiverError);

const
	UnZipDll = 'UnZip32.dll';

var
	UnZipModule: THandle = 0;

function UnZipEnabled: Boolean;
function UnZipGetProcAddress(ProcName: PChar): Pointer;

implementation

function _UnZip(const Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall;
begin
	@UnZip:= UnZipGetProcAddress('UnZip');
	Result:= UnZip(Wnd, CmdLine, Output, Size);
end;

function _UnZipGetVersion: Word; stdcall;
begin
	@UnZipGetVersion:= UnZipGetProcAddress('UnZipGetVersion');
	Result:= UnZipGetVersion;
end;

function _UnZipGetRunning: Bool; stdcall;
begin
	@UnZipGetRunning:= UnZipGetProcAddress('UnZipGetRunning');
	Result:= UnZipGetRunning;
end;

function _UnZipGetBackGroundMode: BOOL; stdcall;
begin
	@UnZipGetBackGroundMode:= UnZipGetProcAddress('UnZipGetBackGroundMode');
	Result:= UnZipGetBackGroundMode;
end;

function _UnZipSetBackGroundMode(const BackGroundMode: BOOL): BOOL; stdcall;
begin
	@UnZipSetBackGroundMode:= UnZipGetProcAddress('UnZipSetBackGroundMode');
	Result:= UnZipSetBackGroundMode(BackGroundMode);
end;

function _UnZipGetCursorMode: BOOL; stdcall;
begin
	@UnZipGetCursorMode:= UnZipGetProcAddress('UnZipGetCursorMode');
	Result:= UnZipGetCursorMode;
end;

function _UnZipSetCursorMode(const CursorMode: BOOL): BOOL; stdcall;
begin
	@UnZipSetCursorMode:= UnZipGetProcAddress('UnZipSetCursorMode');
	Result:= UnZipSetCursorMode(CursorMode);
end;

function _UnZipGetCursorInterval: Word; stdcall;
begin
	@UnZipGetCursorInterval:= UnZipGetProcAddress('UnZipGetCursorInterval');
	Result:= UnZipGetCursorInterval;
end;

function _UnZipSetCursorInterval(const Interval: Word): BOOL; stdcall;
begin
	@UnZipSetCursorInterval:= UnZipGetProcAddress('UnZipSetCursorInterval');
	Result:= UnZipSetCursorInterval(Interval);
end;

function _UnZipCommandLine(Wnd: HWND; hInst: THandle; CmdLine: LPCSTR; CmdShow: DWORD): Integer; stdcall;
begin
	@UnZipCommandLine:= UnZipGetProcAddress('UnZipCommandLine');
	Result:= UnZipCommandLine(Wnd, hInst, CmdLine, CmdShow);
end;

//---------------------------------------------------------------------------

function _UnzipOpenArchive
				(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall;
begin
	@UnzipOpenArchive := UnzipGetProcAddress('UnZipOpenArchive');
	Result := UnzipOpenArchive(Wnd, FileName, Mode);
end;

function _UnzipCloseArchive(Arc: HARC): Integer; stdcall;
begin
	@UnzipCloseArchive := UnzipGetProcAddress('UnZipCloseArchive');
	Result := UnzipCloseArchive(Arc);
end;

function _UnzipFindFirst(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
begin
	@UnzipFindFirst := UnzipGetProcAddress('UnZipFindFirst');
	Result := UnzipFindFirst(Arc, WildName, SubInfo);
end;

function _UnzipFindNext(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
begin
	@UnzipFindNext := UnzipGetProcAddress('UnZipFindNext');
	Result := UnzipFindNext(Arc, SubInfo);
end;

function _UnzipGetAttribute(Arc: HARC): Integer; stdcall;
begin
	@UnzipGetAttribute := UnzipGetProcAddress('UnZipGetAttribute');
	Result := UnzipGetAttribute(Arc);
end;

function _UnzipGetCreateTime(Arc: HARC): DWORD; stdcall;
begin
	@UnzipGetCreateTime := UnzipGetProcAddress('UnZipGetCreateTime');
	Result := UnzipGetCreateTime(Arc);
end;

function _UnzipGetWriteTime(Arc: HARC): DWORD; stdcall;
begin
	@UnzipGetWriteTime := UnzipGetProcAddress('UnZipGetWriteTime');
	Result := UnzipGetWriteTime(Arc);
end;

function _UnzipGetAccessTime(Arc: HARC): DWORD; stdcall;
begin
	@UnzipGetAccessTime := UnzipGetProcAddress('UnZipGetAccessTime');
	Result := UnzipGetAccessTime(Arc);
end;

//---------------------------------------------------------------------------

function UnZipGetProcAddress(ProcName: PChar): Pointer;
begin
	if UnZipModule = 0 then
	begin
		UnZipModule:= SafeLoadLibrary(UnZipDll);
		if UnZipModule = 0 then
			raise EUnZipError.CreateFmt(SFaultLoad, [UnZipDll]);
	end;

	Result:= GetProcAddress(UnZipModule, ProcName);

	if Result = Nil then
		raise EUnZipError.CreateFmt(SNoExistProc, [UnZipDll, ProcName]);
end;

function UnZipEnabled: Boolean;
begin
	if UnZipModule = 0 then
		UnZipModule:= SafeLoadLibrary(UnZipDll);

	Result:= UnZipModule <> 0;
end;

initialization

finalization

	if UnZipModule <> 0 then
		FreeLibrary(UnZipModule);

end.
